// jQuery Handy Accordion v20140102 Beta
// Created by Gyumin Choi

$(function(){
	$.config={
		// 내부 사용 변수
		list:null, // 배너 목록
		listLen:0, // 배너 개수

		// 사용자 필수 정의 변수
		minWidth:0, // 최소 배너 가로 길이(px)
		duration:0, // 움직이는 시간(1000=1초)

		// 사용자 선택 정의 변수
		scr:'.handy_slide', // 배너 스크린 영역
		scrWidth:0, // 스크린(this) 가로 길이(px)
		maxWidth:0, // 최대 배너 가로 길이(px)
		method:'mouseover', // 버튼 작동 방식(mouseover, click)
		autoplay:true, // 자동 재생(true/false)
		timeout:5000, // 다시 재생되는 시간 간격(1000=1초)
		loop:true, // 반복(true/false)
		fade:true, // 페이드 효과(true/false)
		easing:'linear' // 움직이는 효과(http://jqueryui.com/effect/#easing)
	};

	$.fn.handyAccordion=function(defaults){
		var option=$.extend({},$.config,defaults);

		option.scr=$(this).find(option.scr),
		option.list=option.scr.find('>li'),
		option.listLen=option.list.length
		if(option.scrWidth==0) option.scrWidth=$(this).width();
		if(option.maxWidth==0) option.maxWidth=option.scrWidth-((option.list.length-1)*option.minWidth);

		$(this).width(option.scrWidth);
		option.scr.width(option.scrWidth+option.minWidth);
		if(option.scr.find('>.on').html()==null) option.list.eq(0).addClass('on');

		option.list.each(function(i){
			$(this).attr('data-no',i);
			if($(this).hasClass('on')) $(this).width(option.maxWidth);
			else $(this).width(option.minWidth);
		});

		function accordion(no){
			option.list.queue('fx',[]).stop().find('>div').queue('fx',[]).stop();
			if(no>=option.listLen){
				if(option.loop==true) no=0;
				else return false;
			}
			current=option.list.eq(no),
			siblings=current.siblings(),
			old=option.scr.find('>.on')

			if(option.fade==true){
				current.find('>div').animate({'opacity':0},33,function(){
					$(this).animate({'opacity':1},100).parent().addClass('on');
				});
				old.find('>div').animate({'opacity':0},33,function(){
					siblings.find('>div').animate({'opacity':1},100);
					$(this).parent().removeClass('on');
				});
			}else{
				current.addClass('on');
				old.removeClass('on');
			}
			current.animate({'width':option.maxWidth},option.duration,option.easing);
			siblings.animate({'width':option.minWidth},option.duration,option.easing);
		}

		if(option.autoplay==true) var repeat=setInterval(function(){accordion(~~option.scr.find('>.on').attr('data-no')+1)},option.timeout);

		option.list.bind('keyup '+option.method,function(){
			clearInterval(repeat);
			if($(this).hasClass('on')==false) accordion($(this).attr('data-no'));
		});

		option.list.bind('mouseleave',function(){
			if(option.autoplay==true) repeat=setInterval(function(){accordion(~~option.scr.find('>.on').attr('data-no')+1)},option.timeout);
		});
	};
});